"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = require("express");
const basicHandler_1 = require("../basicHandler/basicHandler");
const path = require("path");
class BasicAppHandler extends basicHandler_1.BasicHandler {
    constructor(hardwareHandler) {
        super(hardwareHandler);
        this.router = express_1.Router();
        let _self = this;
        this.router.get('/', (request, response, nextFunction) => {
            _self.getPage(request, response, nextFunction);
        });
        this.router.get('/refresh', (request, response, nextFunction) => {
            _self.refresh(request, response, nextFunction);
        });
        this.router.post('/', (request, response, nextFunction) => {
            _self.getPage(request, response, nextFunction);
        });
        this.router.post('/refresh', (request, response, nextFunction) => {
            _self.refresh(request, response, nextFunction);
        });
        this.init();
        this.pageRouting();
    }
    getRouter() {
        return this.router;
    }
    refresh(request, response, nextFunction) {
    }
    pageRouting() {
        this.router.get('/:page', this.getNewPage);
        this.router.post('/:page', this.getNewPage);
    }
    getPage(request, response, nextFunction) {
        response.sendFile(path.resolve('index.html'));
        console.log('getPage');
    }
    getNewPage(request, response, nextFunction) {
        console.log('request.baseUrl:' + request.path);
        response.cookie('page', request.path.substr(1));
        response.redirect('/');
        console.log('getNewPage');
    }
}
exports.BasicAppHandler = BasicAppHandler;
//# sourceMappingURL=basicAppHandler.js.map