"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const basicsocket_1 = require("basicsocket");
const IV_LENGTH = 16;
class BasicApi {
    constructor(appHandler, externalHandler) {
        this.arraySocketExternal = new Array();
        this.arraySocketClient = new Array();
        this.appHandler = appHandler;
        this.externalHandler = externalHandler;
    }
    getRouter() {
        return this.appHandler.getRouter();
    }
    addSocket(socket) {
        this.inspectSocket(socket);
    }
    setIo(io) {
        this.io = io;
    }
    afterListen() {
        let _self = this;
        this.io.on('connection', (socket) => { _self.addSocket(socket); });
    }
    inspectSocket(ioSocket) {
        let socket = new basicsocket_1.Socket(ioSocket);
        let basicSocket = socket.getBasicSocket();
        let key = basicsocket_1.BasicSocket.generateKey(32);
        basicSocket.emit('getIdentification', key);
        basicSocket.setKey(key);
        basicSocket.on('identification', (identification) => {
            basicSocket.setIdentification(identification);
            switch (identification.type) {
                case 'app':
                    this.appHandler.addSocket(socket);
                    break;
                default:
                    this.externalHandler.addSocket(socket);
                    break;
            }
        });
    }
}
exports.BasicApi = BasicApi;
//# sourceMappingURL=basicApi.js.map