"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class BasicHandler {
    constructor(hardwareHandler) {
        this.arraySocket = new Array();
        this.hardwareHandler = hardwareHandler;
    }
    addSocket(socket) {
        let _self = this;
        let basicSocket = socket.getBasicSocket();
        basicSocket.on('disconnect', (reason) => { _self.onServerDisconnected(socket, reason); });
        this.configSocket(socket);
        this.onServerConnected(socket);
    }
    configSocket(socket) { }
    init() { }
    serverConnected(socket) {
        console.log('CONNECTED');
    }
    serverDisconnected(socket, reason) {
        console.log('DISCONNECTED', reason);
    }
    onServerConnected(socket) {
        this.arraySocket.push(socket);
        this.serverConnected(socket);
    }
    onServerDisconnected(socket, reason) {
        let index = this.arraySocket.indexOf(socket);
        if (index > -1) {
            this.arraySocket.splice(index, 1);
        }
        this.serverDisconnected(socket, reason);
    }
}
exports.BasicHandler = BasicHandler;
//# sourceMappingURL=basicHandler.js.map