"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const basicsocket_1 = require("basicsocket");
const basicHandler_1 = require("./../basicHandler/basicHandler");
const ioClient = require("socket.io-client");
class BasicExternalHandler extends basicHandler_1.BasicHandler {
    constructor(hardwareHandler) {
        super(hardwareHandler);
        this.arraySocketClient = new Array();
        this.init();
    }
    connectToServer(serverAddress, identification) {
        let _self = this;
        let socketClient = ioClient(serverAddress);
        socketClient.on('connect', () => { _self.onClientConnected(socketClient, serverAddress, identification); });
    }
    clientConnected(socket) {
        console.log('CONNECTED');
    }
    clientDisconnected(socket, reason) {
        console.log('DISCONNECTED', reason);
    }
    configSocketClient(socket) { }
    onClientConnected(socketClient, serverAddress, identification) {
        let _self = this;
        if (identification === undefined || identification === null) {
            identification = {};
        }
        identification['type'] = 'external';
        identification['serverAddress'] = serverAddress;
        let socket = new basicsocket_1.Socket(socketClient);
        let basicSocket = socket.getBasicSocket();
        basicSocket.setIdentification(identification);
        basicSocket.on('getIdentification', (key) => {
            basicSocket.setKey(key);
            basicSocket.emit('identification', identification);
            this.configSocketClient(socket);
            this.clientConnected(socket);
        });
        basicSocket.on('disconnect', (reason) => { _self.onClientDisconnected(socket, reason); });
        this.arraySocketClient.push(socket);
    }
    onClientDisconnected(socket, reason) {
        let index = this.arraySocket.indexOf(socket);
        if (index > -1) {
            this.arraySocket.splice(index, 1);
        }
        this.clientDisconnected(socket, reason);
    }
}
exports.BasicExternalHandler = BasicExternalHandler;
//# sourceMappingURL=basicExternalHandler.js.map